walltiles = {}
walltile = {}
function walltile:New(x, y)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64*LEVELDS
	obj.h = 64*LEVELDS
	function obj:update(dt)
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) and LETSBEGINPLAY then
			doGameOver()
		end
	end
	function obj:draw()
		love.graphics.draw(wallimg, self.x, self.y, 0, LEVELDS, LEVELDS, 0, 0, 0, 0)
	end
	return obj
end
gentiles = {}
gentile = {}
gentilequads = {}
gentilequads[1] = love.graphics.newQuad(0, 0, 64, 64, 256, 64)
gentilequads[2] = love.graphics.newQuad(64, 0, 64, 64, 256, 64)
gentilequads[3] = love.graphics.newQuad(128, 0, 64, 64, 256, 64)
gentilequads[4] = love.graphics.newQuad(192, 0, 64, 64, 256, 64)
function gentile:New(x, y)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64*LEVELDS
	obj.h = 64*LEVELDS
	obj.frame = 0
	obj.frametime = 0
	function obj:update(dt)
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) then
			if self.frame >= 4 then
				doGameOver()
			else
				self.active = true
			end
		end
		if self.frame < 4 and self.active then
			self.frametime = self.frametime + 100*dt
			if self.frametime > 10 then
				self.frametime = 0
				self.frame = self.frame + 1
			end
		end
	end
	function obj:draw()
		if self.frame < 5 and self.frame > 0 then
			love.graphics.drawq(genimg, gentilequads[self.frame], self.x, self.y, 0, LEVELDS, LEVELDS, 0, 0, 0, 0)
		end
	end
	return obj
end
signtile = {}
signtile = {}
function signtile:New(x, y)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64*LEVELDS
	obj.h = 64*LEVELDS
	function obj:update(dt)
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) then
			READINGSIGN = true
		end
	end
	function obj:draw()
		love.graphics.draw(signimg, self.x, self.y, 0, LEVELDS, LEVELDS, 0, 0, 0, 0)
	end
	return obj
end
nexttiles = {}
nexttile = {}
nexttilequads = {}
nexttilequads[1] = love.graphics.newQuad(0, 0, 64, 64, 512, 64)
nexttilequads[2] = love.graphics.newQuad(64, 0, 64, 64, 512, 64)
nexttilequads[3] = love.graphics.newQuad(128, 0, 64, 64, 512, 64)
nexttilequads[4] = love.graphics.newQuad(192, 0, 64, 64, 512, 64)
nexttilequads[5] = love.graphics.newQuad(256, 0, 64, 64, 512, 64)
nexttilequads[6] = love.graphics.newQuad(320, 0, 64, 64, 512, 64)
nexttilequads[7] = love.graphics.newQuad(384, 0, 64, 64, 512, 64)
nexttilequads[8] = love.graphics.newQuad(448, 0, 64, 64, 512, 64)
function nexttile:New(x, y)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64*LEVELDS
	obj.h = 64*LEVELDS
	obj.frame = 1
	obj.frametime = 0
	function obj:update(dt)
		self.frametime = self.frametime + 100*dt
		if self.frametime > 10 then
			self.frametime = 0
			self.frame = self.frame + 1
			if self.frame > 8 then
				self.frame = 1
			end
		end
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) then
			nextsnd:stop()
			nextsnd:play()
			doNextLevel(LEVELDESC)
		end
	end
	function obj:draw()
		love.graphics.drawq(nextimg, nexttilequads[self.frame], self.x, self.y, 0, LEVELDS, LEVELDS, 0, 0, 0, 0)
	end
	return obj
end
keytiles = {}
keytile = {}
function keytile:New(x, y)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64*LEVELDS
	obj.h = 64*LEVELDS
	obj.collected = false
	function obj:update(dt)
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) and not self.collected then
			self.collected = true
			KEYS = KEYS + 1
			keysnd:stop()
			keysnd:play()
		end
	end
	function obj:draw()
		if not self.collected then love.graphics.draw(keyimg, self.x, self.y, 0, LEVELDS, LEVELDS, 0, 0, 0, 0) end
	end
	return obj
end
teletiles = {}
teletile = {}
function teletile:New(x, y)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64*LEVELDS
	obj.h = 64*LEVELDS
	function obj:update(dt)
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) then
			doTelePort()
		end
	end
	function obj:draw()
		love.graphics.draw(teleimg, self.x, self.y, 0, LEVELDS, LEVELDS, 0, 0, 0, 0)
	end
	return obj
end
porttiles = {}
porttile = {}
function porttile:New(x, y)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64*LEVELDS
	obj.h = 64*LEVELDS
	function obj:update(dt)
		if TELEPORTING then
			love.mouse.setPosition(self.x+32*LEVELDS, self.y+32*LEVELDS)
			TELEPORTING = false
		end
	end
	function obj:draw()
		love.graphics.draw(portimg, self.x, self.y, 0, LEVELDS, LEVELDS, 0, 0, 0, 0)
	end
	return obj
end
zaptiles = {}
zaptile = {}
function zaptile:New(x, y, timeOffset)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64*LEVELDS
	obj.h = 64*LEVELDS
	obj.zaptime = timeOffset or 0
	function obj:update(dt)
		self.zaptime = self.zaptime + 100*dt
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) and self.zaptime > 100 then
			doGameOver()
		end
		if self.zaptime > 200 then self.zaptime = 0 end
	end
	function obj:draw()
		if self.zaptime > 100 then love.graphics.draw(zapimg, self.x, self.y, 0, LEVELDS, LEVELDS, 0, 0, 0, 0) end
	end
	return obj
end
doortiles = {}
doortile = {}
doorquads = {}
doorquads[1] = love.graphics.newQuad(0, 0, 64, 64, 256, 64)
doorquads[2] = love.graphics.newQuad(64, 0, 64, 64, 256, 64)
doorquads[3] = love.graphics.newQuad(128, 0, 64, 64, 256, 64)
doorquads[4] = love.graphics.newQuad(192, 0, 64, 64, 256, 64)
function doortile:New(x, y)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64*LEVELDS
	obj.h = 64*LEVELDS
	obj.unlocked = false
	obj.frame = 1
	obj.frametime = 0
	obj.dying = false
	function obj:update(dt)
		if self.dying and self.frame < 5 then
			self.frametime = self.frametime + 100*dt
			if self.frametime > 1 then
				self.frame = self.frame + 1
				self.frametime = 0
			end
		end
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) then
			if KEYS > 0 and not self.unlocked then
				self.unlocked = true
				self.dying = true
				KEYS = KEYS - 1
				doorsnd:stop()
				doorsnd:play()
				self.dying = true
			elseif not self.unlocked then
				doGameOver()
			end
		end
	end
	function obj:draw()
		if self.frame < 5 then 
			love.graphics.drawq(doorimg, doorquads[self.frame], self.x, self.y, 0, LEVELDS, LEVELDS, 0, 0, 0, 0)
		end
	end
	return obj
end